COMMENT @
kudos to Tobias Nissen/ http://www.eggheadcafe.com/software/aspnet/29502197/get-text-from-nonowned-s.aspx

This app retrieves text items from typical
status bars built with MFC, ATL or WTL.
It uses the SB_GETTEXT message, which 
requires interprocess memory sharing.

Cheers, jj2007
@

include \masm32\include\masm32rt.inc
.stack 4096

show	EQU invoke ShowNum,	; use dwtoa to show a number
crlf	EQU 13,10
ShowNum	PROTO :DWORD	; show a number, e.g. ShowNum eax
ShowWinErr	PROTO :DWORD	; GetLastError; 0=as number, 1=formatted

.data?
pTw	dd ?	; pointer to target window
hTw	dd ?	; target window
pid	dd ?	; process id
hProc	dd ?	; handle to process
pShM	dd ?	; pointer to shared memory
id	dd ?	; # of control
hc	dd ?	; handle to control
pTmp		dd ?	; pointer to temporary buffer
TmpBuf	db 512 dup(?)
pShow		dd ?	; pointer to final buffer
ShowBuf	db 1024 dup(?)

.data
AppError	db	"See LastError?",0
AppName	db	"SB_GETTEXT",0
AppMsg	db	"Getting status bar text across processes:",0
ShowErr	db "GetLastError:", crlf
ShowErrBuf	db 200 dup(0)		; 200 chars for Windows
NumBuf	db "A number for you:", crlf, crlf,0

.code
ie		dd 1	; MSIE - this works in principle
msw		dd 0	; if not MSIE, try Word? nope...
msx		dd 0	; if not Word, try Excel? nope...
ppt		dd 0	; or Powerpoint? nope...
oex		dd 0	; if all fails, Outlook? YEP, it works!
; and all zero means try and Editor2 window built on WTL

tw1	db "Recent Unread Topics - Microsoft Internet Explorer", 0
tw2	db "Document1 - Microsoft Word", 0
tw3	db "Microsoft Excel - Book1", 0
tw4	db "Microsoft PowerPoint - [Presentation1]", 0
tw5	db "Inbox - Outlook Express", 0
tw6	db "dummy.txt @ D:\wwn\asm\",0  ; this is Nikos Bozini's Editor2

start:	.if ie
		mov pTw, offset tw1	; MS Internet Explorer example
	.elseif msw
		mov pTw, offset tw2
	.elseif msx
		mov pTw, offset tw3
	.elseif ppt
		mov pTw, offset tw4
	.elseif oex
		mov pTw, offset tw5
	.else
		mov pTw, offset tw6
	.endif
	invoke FindWindowEx, 0, 0, 0, pTw	; make sure text matches!
	.if eax==0
		invoke MessageBox, NULL, pTw, chr$("No such window"), MB_OK
	.else
	mov hTw, eax
	.if ie
		invoke GetDlgItem, hTw, 0A001h
	.elseif msw
		invoke FindWindowEx, hTw, 0, 0C1B4h, 0
	.elseif msx
		invoke FindWindowEx, hTw, 0, 0C1FCh, 0
	.elseif ppt || oex
		; invoke GetDlgItem, hTw, 1	; same control
		invoke FindWindowEx, hTw, 0, 0C041h, 0
	.else
		invoke GetDlgItem, hTw, 0E801h
	.endif
	.if eax==0
		invoke MessageBox, 0,
		chr$("Status bar not found"),
		pTw, MB_OK
		invoke ExitProcess, 0
	.endif
	mov hc, eax
	mov pTmp, offset TmpBuf
	mov edx, offset ShowBuf
	xor eax, eax
	mov [edx], eax
	mov pShow, edx
	; invoke lstrcat, pShow, chr$("Welcome to an interesting app")
	; invoke MessageBox, NULL, pShow, addr AppName, MB_OK
	invoke GetWindowThreadProcessId, hc, addr pid
	invoke OpenProcess,
	PROCESS_VM_OPERATION or PROCESS_VM_READ or\
	PROCESS_QUERY_INFORMATION, 0, pid
	mov hProc, eax
	invoke VirtualAllocEx, hProc, 0, 512,
	MEM_COMMIT or MEM_RESERVE, PAGE_READWRITE
	mov pShM, eax
	invoke RtlZeroMemory, pShow, 800 ;SIZEOF ShowBuf
	invoke lstrcat, pShow, addr AppMsg
	mov id, 0
	.WHILE id<9
	invoke SendMessage, hc, SB_GETTEXT, id, pShM
	and eax, 65535	; len of text in loword
	.IF eax
		invoke RtlZeroMemory, pTmp, 512
		invoke ReadProcessMemory, hProc, pShM, pTmp, 512, 0
		invoke lstrcat, pShow, chr$(crlf)
		invoke lstrcat, pShow, str$(id)
		invoke lstrcat, pShow, chr$(9)
		invoke lstrcat, pShow, pTmp
	.endif
	inc id
	.ENDW
	invoke VirtualFreeEx, hProc, pShM, 0, MEM_RELEASE
	invoke CloseHandle, hProc
	.IF eax==0
		invoke ShowWinErr, 1
	.ENDIF
	invoke MessageBox, NULL, pShow, addr AppName, MB_OK
	.if eax==IDYES
		invoke ShowWinErr, 1
	.endif
	.endif
	invoke ExitProcess, 0

ShowNum proc Numb:DWORD
	pushad
	  invoke dwtoa, Numb, addr NumBuf
	  invoke MessageBox, NULL, addr NumBuf, addr AppName, MB_OK
	popad
	ret
ShowNum endp

ShowWinErr proc ShowFormatted:DWORD
 push	eax
 invoke GetLastError
 .IF ShowFormatted
    invoke FormatMessage, FORMAT_MESSAGE_FROM_SYSTEM,
    0,	; GetItFromSystem
    eax,	; ErrNum
    0,	; Default language
    ADDR ShowErrBuf,	; where to send the address of string from system
    200,0            	; size 200, no arguments
    invoke MessageBox, 0, ADDR ShowErr, ADDR AppName, MB_OKCANCEL
 .ELSE
    invoke ShowNum,eax
    invoke MessageBox,0,ADDR ShowErr,ADDR AppName,MB_OKCANCEL
 .ENDIF
 pop eax
ret
ShowWinErr endp

end start
; OPT_SUSY WINDOWS
